/*******************************************************************
*
*  DESCRIPTION: class CarControlUnit 
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 02/05/2003
*
*******************************************************************/

#ifndef __CAR_CU_H
#define __CAR_CU_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException

/** declarations **/
class CarControlUnit : public Atomic
{
public:
    CarControlUnit (const string &name = "CarControlUnit"); // Default constructor

    virtual string className () const
        {return "CarControlUnit";}

protected:
    Model &initFunction () ;
    Model &externalFunction (const ExternalMessage &);            
    Model &internalFunction (const InternalMessage &);
    Model &outputFunction (const InternalMessage &);

private:
	typedef enum phases {NONE, OPEN_NORTH, CLOSE_NORTH, OPEN_SOUTH, CLOSE_SOUTH};
	typedef enum direction {NORTH, SOUTH};

	int max_north;           // Parametros....
	int max_south;
	Time timeout;
	
    direction way;           // Aca tengo el sentido de transito.
    phases phase;            // Auxiliar para saber que enviar como salida.
    long total;              // Cuenta de cuantos autos pasaron.
    long in_transit;         // Cuenta de cuantos autos hay en transito.

    // Input Ports  
    const Port &in;
    const Port &out;
    
    // Output Ports
    Port &opens;
    Port &openn;
            
};  // class CarControlUnit


#endif   //__CAR_CU_H 
