/*******************************************************************
*
*  DESCRIPTION: class Distributor
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 01/05/2003
*
*******************************************************************/

#ifndef __DISTRIBUTOR_H
#define __DISTRIBUTOR_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException

/** declarations **/
class Distributor : public Atomic
{
public:
    Distributor (const string &name = "Distributor");     // Default constructor

    virtual string className () const
        {return "Distributor";}

protected:
    Model &initFunction () ;
    Model &externalFunction (const ExternalMessage &);            
    Model &internalFunction (const InternalMessage &);
    Model &outputFunction (const InternalMessage &);

private:
	typedef enum direction {UNKNOWN, TO_NORTH, TO_SOUTH};
	typedef enum phases {NONE, NORTH, TRANSIT, SOUTH};

    int id_in, id_done;      // Aca guardo los id's de los vehiculos en transito.
    direction way;           // Me indica en que sentido esta funcionando el tramo.
    phases phase;            // Auxiliar para saber por que output emitir la salida.
    bool signal_open;        // Indica si el semaforo esta abierto o cerrado.
    
    // Input Ports
    const Port &opens;
    const Port &openn;
    const Port &in;
    const Port &done;

    // Output Ports
    Port &outs;
    Port &outn;
    Port &out_tra;

};  // class Distributors


#endif   //__DISTRIBUTOR_H 
