/*******************************************************************
*
*  DESCRIPTION: class Queue
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 04/05/2003
*
*******************************************************************/

#ifndef __QUEUE_H
#define __QUEUE_H

#include <list>
#include "atomic.h"     // class Atomic

class Queue : public Atomic {
public:
	Queue( const string &name = "Queue" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction ();
	Model &externalFunction (const ExternalMessage &);
	Model &internalFunction (const InternalMessage &);
	Model &outputFunction (const InternalMessage &);

private:
	const Port &in;
	const Port &start;
	Port &out;
	Time preparationTime;
	typedef list<Value> ElementList ;
	ElementList elements ;

};	// class Queue

// ** inline ** // 
inline
string Queue::className() const
{
	return "Queue" ;
}

#endif   //__QUEUE_H
