/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "queue.h"        // class Queue
#include "generat.h"      // class Generator
#include "cpu.h"          // class CPU
#include "transduc.h"     // class Transducer
#include "trafico.h"      // class Trafico
// Nuestros Modelos Atomicos.
#include "traffic.h"      // class Traffic
#include "analizer.h"     // class Analizer
#include "distributor.h"  // class Distributor
#include "time_cu.h"      // class TimeControlUnit
#include "car_cu.h"       // class CarControlUnit
#include "transit.h"      // class Transit

void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Traffic>() , "Traffic" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Analizer>() , "Analizer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Distributor>() , "Distributor" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TimeControlUnit>() , "TimeControlUnit" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CarControlUnit>() , "CarControlUnit" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transit>() , "Transit" ) ;
}
