/*******************************************************************
*
*  DESCRIPTION: class TimeControlUnit
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 02/05/2003
*
*******************************************************************/

#ifndef __TIME_CU_H
#define __TIME_CU_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException

/** declarations **/
class TimeControlUnit : public Atomic
{
public:
    TimeControlUnit (const string &name = "TimeControlUnit");   // Default constructor
	
    virtual string className () const
        {return "TimeControlUnit";}

protected:
    Model &initFunction () ;
    Model &externalFunction (const ExternalMessage &);            
    Model &internalFunction (const InternalMessage &);
    Model &outputFunction (const InternalMessage &);

private:
	typedef enum phases {OPEN_NORTH, IN_NORTH, CLOSE_NORTH, FREE_NORTH, 
	                     OPEN_SOUTH, IN_SOUTH, CLOSE_SOUTH, FREE_SOUTH};

	Time max_north;
	Time max_south;
    phases phase;            // Estado en el que me encuentro.
    long in_transit;         // Cuenta de cuantos autos hay en transito.

    // Input Ports  
    const Port &in;
    const Port &out;
    
    // Output Ports
    Port &opens;
    Port &openn;
            
};  // class TimeControlUnit


#endif   //__TIME_CU_H 
