/*******************************************************************
*
*  DESCRIPTION: class Traffic
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 26/04/2003
*
*******************************************************************/

#ifndef __TRAFFIC_H
#define __TRAFFIC_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException

/** forward declarations **/
class Distribution ;

/** declarations **/
class Traffic : public Atomic
{
public:
    Traffic (const string &name = "Traffic");     // Default constructor
    ~Traffic ();

    virtual string className () const
        {return "Traffic";}

protected:
    Model &initFunction () ;
    Model &externalFunction (const ExternalMessage &);            
    Model &internalFunction (const InternalMessage &);
    Model &outputFunction (const InternalMessage &);

private:
    int pid;
    int initial, increment;
    
    const Port &stop;
    Port &out ;
    Distribution *dist;

    Distribution &distribution ()
    	{return *dist;}
            
};  // class Traffic


#endif   //__TRAFFIC_H 
