/*******************************************************************
*
*  DESCRIPTION: class Transit
*
*  AUTHOR: Pablo Demidoff & Carlos Miracola 
*
*  EMAIL: mailto: pd4f@dc.uba.ar
*         mailto: cmiracol@dc.uba.ar
*
*  DATE: 03/05/2003
*
*******************************************************************/

#ifndef __TRANSIT_H
#define __TRANSIT_H

#include <map.h>
#include "atomic.h"
#include "message.h"

class Transit: public Atomic
{
public:
    Transit (const string &name = "Transit");     //Default constructor

    virtual string className () const ;

protected:
    Model &initFunction ();
    Model &externalFunction (const ExternalMessage &);
    Model &internalFunction (const InternalMessage &);
    Model &outputFunction (const InternalMessage &);

private:
    typedef map < int, Time, less<int> > JobsList ;

    // Input Ports
    const Port &in;

    // Output Ports
    Port &out;

	int id;
    JobsList unsolved; 
	Time delay;
	
};  // class Transit

// ** inline ** // 
inline
string Transit::className () const {
    return "Transit";
}

#endif   //__TRANSIT_H 
